#!/bin/sh

unzip -o /recovery/SGW1000S.zip -d /userdata/download

#get file MD5
if [ -s /userdata/download/version_conf ] && [ -s /userdata/download/work.tar.gz ]; then
	md5_conf=`grep -r MD5 /userdata/download/version_conf | cut -d " " -f2`
	md5_check=`md5sum /userdata/download/work.tar.gz | cut -c1-32`
else
	echo "`date`: software remote update file is not exist!" >>/work/tcp_update_log
	reboot
	exit 0
fi

#check MD5
if [ "$md5_conf" == "" ] || [ "$md5_conf" != "$md5_check" ]; then
	echo "`date`:software remote update failed, please check your file!" >>/work/tcp_update_log
	reboot
	exit 0
fi

#if [ -f $1 ]
#then
echo 0 > /etc/check
ps | grep -v init | grep -v sh | cut -c 0-5 | sed '/P.*/d' | xargs kill -9

killall koti_deamon
killall koti_deamon_v
killall koti_gateway
killall restore_config
killall pc_sync
killall wpa_supplicant

#rmmod pwm_device
#rmmod pwm_driver
#rmmod sec_driver
#rmmod cc1101
#rmmod 8192cu


tar -zxvf /userdata/download/work.tar.gz -C /userdata/download

cp -a /userdata/download/updatefiles/*.so*  /lib/
cp -a /userdata/download/updatefiles/upload_tar.sh  /config/sys/upload_tar.sh
cp -a /userdata/download/updatefiles/rc.start /etc/rc.d/rc.start
cp -a /userdata/download/updatefiles/ntp.cron /etc/cron/crontabs/ntp.cron
chmod 777 /config/sys/upload_tar.sh
chmod 777 /etc/rc.d/rc.start

#new wpa config tools
cp -a /userdata/download/updatefiles/wpa_cli /usr/bin/wpa_cli
cp -a /userdata/download/updatefiles/wpa_passphrase /usr/bin/wpa_passphrase
cp -a /userdata/download/updatefiles/wpa_supplicant /usr/bin/wpa_supplicant
cp -a /userdata/download/backup/wpa_supplicant_connect.conf /etc/wpa_supplicant.conf

rm -rf /work/*
sync

umount /work
ubirmvol /dev/ubi0 -n 1
ubimkvol /dev/ubi0 -n 1 -N work -s 10MiB
mount -t ubi0:work /work
tar xzvf /userdata/download/work.tar.gz -C /work/
rm -rf /userdata/download/*
sync
sleep 3
sed -i "/modelVersion/{s/>.*</>`sed -n -e '/modelVersion/p' /work/backup/device.xml | cut -d ">" -f2 |cut -d "<" -f1`</g}" /config/user/device.xml
cp /config/user/device.xml /config/sys/device.xml 
sync 

#upgrade to v1
if [ -f /work/updatefiles/work.tar.gz ]
then
cp /work/updatefiles/work.tar.gz /userdata/download
tar -zxvf /work/updatefiles/work.tar.gz -C /userdata/download
cp -a /userdata/download/updatefiles/*.so* /lib/
cp -a /userdata/download/backup/koti_conf /config/koti_conf
cp -a /userdata/download/backup/rf_conf /config/user/rf_conf
#cp -a /userdata/download/backup/koti.kotix /config/user/koti.kotix
cp -a /userdata/download/backup/platforminfo_conf /config/user/platforminfo_conf
#cp -a /userdata/download/backup/config.xml /config/user/config.xml
#cp -a /userdata/download/backup/device.xml /config/user/device.xml
cp -a /userdata/download/backup/device.xml /config/device.xml
cp -a /userdata/download/updatefiles/upload_tar.sh /config/sys/upload_tar.sh

cp -a /userdata/download/updatefiles/rc.start /etc/rc.d/rc.start
cp -a /userdata/download/updatefiles/ntp.cron /etc/cron/crontabs/ntp.cron
cp -a /work/backup/wpa_supplicant_connect.conf /etc/wpa_supplicant.conf
#cp -a /userdata/download/backup/koti.kotix /recovery/koti.kotix
cp -a /userdata/download/backup/koti_conf /recovery/koti_conf
cp -a /userdata/download/backup/rf_conf /recovery/rf_conf
cp -a /userdata/download/backup/platforminfo_conf /recovery/platforminfo_conf
rm -rf /recovery/koti.kotix
chmod 777 /config/sys/upload_tar.sh
chmod 777 /etc/rc.d/rc.start

rm -rf /work/*
sleep 1

umount /work
ubirmvol /dev/ubi0 -n 1
ubimkvol /dev/ubi0 -n 1 -N work -s 10MiB
mount -t ubi0:work /work
tar xzvf /userdata/download/work.tar.gz -C /work/
rm -rf /userdata/download/*

sync
fi
rm -rf /recovery/SGW1000S.zip
sync
reboot
#fi

